//-----------------------------------------
// Author: Chris Kelly
// Course: CS110, Summer 2014
// University: UMass Boston
//-----------------------------------------

public class PrimTypes{
  
  public static void main(String[] args){
 
    byte b = 54;
    short s = 7526;
    int i = -1439876;
    long l = 461168601413240608l;
    float f = 1442776.875f;
    double d = 4611686014132.4206081;
    char c = 'z';
    
    System.out.println("byte   (2^ 8 possible values): " + printNumber(b));
    System.out.println("short  (2^16 possible values): " + printNumber(s));
    System.out.println("int    (2^32 possible values): " + printNumber(i));
    System.out.println("long   (2^64 possible values): " + printNumber(l));
    System.out.println("float  (2^32 possible values): " + printNumber(f));
    System.out.println("double (2^64 possible values): " + printNumber(d));
    System.out.println("char   (2^16 possible values): " + printNumber(c));
 
  }
  
  private static String printNumber(byte b){
    return String.format("%8s", Long.toBinaryString(b)).replace(' ', '0');
  }
  
  private static String printNumber(short s){
    return String.format("%16s", Long.toBinaryString(s)).replace(' ', '0');
  }
  
  private static String printNumber(int i){
    return String.format("%32s", Integer.toBinaryString(i)).replace(' ', '0');
  }
  
  private static String printNumber(long l){
    return String.format("%64s", Long.toBinaryString(l)).replace(' ', '0');
  }
  
  private static String printNumber(float f){
    return String.format("%32s", Integer.toBinaryString(Float.floatToRawIntBits(f))).replace(' ', '0');
  }
  
  private static String printNumber(double d){
    return String.format("%64s", Long.toBinaryString(Double.doubleToRawLongBits(d))).replace(' ', '0');
  }
  
  private static String printNumber(char c){
    return String.format("%16s", Long.toBinaryString(c)).replace(' ', '0');
  }
  
}